#include <sourcemod>
#include <sdktools>

//class = GetEntProp(client, Prop_Send, "m_iPlayerClass")
//0 = Rifleman
//1 = Assault
//2 = Support
//3 = Sniper
//4 = MG
//5 = Rocket

#define TEAM_AMER 2
#define TEAM_AXIS 3

#define MDL_AMER_RIFLEMAN  "models/player/ics/allied_rifleman/american_rifleman.mdl"
#define MDL_AMER_ASSAULT   "models/player/ics/allied_assault/american_assault.mdl"
#define MDL_AMER_SUPPORT   "models/player/ics/allied_support/american_support.mdl"
#define MDL_AMER_SNIPER    "models/player/ics/allied_sniper/american_sniper.mdl"
#define MDL_AMER_MG        "models/player/ics/allied_mg/american_mg.mdl"
#define MDL_AMER_ROCKET    "models/player/ics/allied_rocket/american_rocket.mdl"
#define MDL_AXIS_RIFLEMAN  "models/player/ics/axis_rifleman/german_rifleman.mdl"
#define MDL_AXIS_ASSAULT   "models/player/ics/axis_assault/german_assault.mdl"
#define MDL_AXIS_SUPPORT   "models/player/ics/axis_support/german_support.mdl"
#define MDL_AXIS_SNIPER    "models/player/ics/axis_sniper/german_sniper.mdl"
#define MDL_AXIS_MG        "models/player/ics/axis_mg/german_mg.mdl"
#define MDL_AXIS_ROCKET    "models/player/ics/axis_rocket/german_rocket.mdl"

#define ADMINS_SKINS_CLASS_SET_VERSION		"1.0"

new Handle:g_version = INVALID_HANDLE;

new String:g_modelAmerName[][] = 
{
	"models/player/ics/allied_rifleman/american_rifleman.mdl", 
	"models/player/ics/allied_assault/american_assault.mdl", 
	"models/player/ics/allied_support/american_support.mdl", 
	"models/player/ics/allied_sniper/american_sniper.mdl", 
	"models/player/ics/allied_mg/american_mg.mdl", 
	"models/player/ics/allied_rocket/american_rocket.mdl"
}

new String:g_modelAxisName[][] = 
{
	"models/player/ics/axis_rifleman/german_rifleman.mdl", 
	"models/player/ics/axis_assault/german_assault.mdl", 
	"models/player/ics/axis_support/german_support.mdl", 
	"models/player/ics/axis_sniper/german_sniper.mdl", 
	"models/player/ics/axis_mg/german_mg.mdl", 
	"models/player/ics/axis_rocket/german_rocket.mdl"
}

public Plugin:myinfo = 
{
	name = "ADMINS SKINS CLASS SET", 
	author = "Andi67, Vintage", 
	description = "Skins admins ICS models", 
	version = "ADMINS_SKINS_CLASS_SET_VERSION", 
	url = "http://www.dodsplugins.net"
}

public OnClientAuthorized(client, const String:auth[])
{
	QueryClientConVar(client, "cl_downloadfilter", ConVarQueryFinished:dlfilter);
}

public dlfilter(QueryCookie:cookie, client, ConVarQueryResult:result, const String:cvarName1[], const String:cvarValue1[])
{
	if (IsClientConnected(client))
	{
		if (strcmp(cvarValue1, "none", true) == 0)
		{
			KickClient(client, "Please enable SkinDownload and reconnect!");
		}
	}
}

public OnMapStart()
{
	g_version = CreateConVar("admins_skins_class_set_version", ADMINS_SKINS_CLASS_SET_VERSION, "ADMINS SKINS CLASS SET VERSION", FCVAR_NOTIFY);
	SetConVarString(g_version, ADMINS_SKINS_CLASS_SET_VERSION);
	HookEvent("player_spawn", Event_PlayerSpawn, EventHookMode_Pre);
	InitFiles();
}

InitFiles()
{
	PrecacheModel("models/player/ics/allied_rifleman/american_rifleman.mdl");
	PrecacheModel("models/player/ics/allied_assault/american_assault.mdl");
	PrecacheModel("models/player/ics/allied_support/american_support.mdl");
	PrecacheModel("models/player/ics/allied_sniper/american_sniper.mdl");
	PrecacheModel("models/player/ics/allied_mg/american_mg.mdl");
	PrecacheModel("models/player/ics/allied_rocket/american_rocket.mdl");
	PrecacheModel("models/player/ics/axis_rifleman/german_rifleman.mdl");
	PrecacheModel("models/player/ics/axis_assault/german_assault.mdl");
	PrecacheModel("models/player/ics/axis_support/german_support.mdl");
	PrecacheModel("models/player/ics/axis_sniper/german_sniper.mdl");
	PrecacheModel("models/player/ics/axis_mg/german_mg.mdl");
	PrecacheModel("models/player/ics/axis_rocket/german_rocket.mdl");
	///////////////////////////////// models allies
	//Allies materials
	AddFileToDownloadsTable("materials/models/player/ics/allied_admin/american_body.vmt");
	AddFileToDownloadsTable("materials/models/player/ics/allied_admin/american_body.vtf");
	AddFileToDownloadsTable("materials/models/player/ics/allied_admin/american_gear.vmt");
	AddFileToDownloadsTable("materials/models/player/ics/allied_admin/american_gear.vtf");
	//Allies models
	AddFileToDownloadsTable("models/player/ics/allied_assault/american_assault.dx80.vtx");
	AddFileToDownloadsTable("models/player/ics/allied_assault/american_assault.dx90.vtx");
	AddFileToDownloadsTable("models/player/ics/allied_assault/american_assault.mdl");
	AddFileToDownloadsTable("models/player/ics/allied_assault/american_assault.phy");
	AddFileToDownloadsTable("models/player/ics/allied_assault/american_assault.sw.vtx");
	AddFileToDownloadsTable("models/player/ics/allied_assault/american_assault.vvd");
	AddFileToDownloadsTable("models/player/ics/allied_mg/american_mg.dx80.vtx");
	AddFileToDownloadsTable("models/player/ics/allied_mg/american_mg.dx90.vtx");
	AddFileToDownloadsTable("models/player/ics/allied_mg/american_mg.mdl");
	AddFileToDownloadsTable("models/player/ics/allied_mg/american_mg.phy");
	AddFileToDownloadsTable("models/player/ics/allied_mg/american_mg.sw.vtx");
	AddFileToDownloadsTable("models/player/ics/allied_mg/american_mg.vvd");
	AddFileToDownloadsTable("models/player/ics/allied_rifleman/american_rifleman.dx80.vtx");
	AddFileToDownloadsTable("models/player/ics/allied_rifleman/american_rifleman.dx90.vtx");
	AddFileToDownloadsTable("models/player/ics/allied_rifleman/american_rifleman.mdl");
	AddFileToDownloadsTable("models/player/ics/allied_rifleman/american_rifleman.phy");
	AddFileToDownloadsTable("models/player/ics/allied_rifleman/american_rifleman.sw.vtx");
	AddFileToDownloadsTable("models/player/ics/allied_rifleman/american_rifleman.vvd");
	AddFileToDownloadsTable("models/player/ics/allied_rocket/american_rocket.dx80.vtx");
	AddFileToDownloadsTable("models/player/ics/allied_rocket/american_rocket.dx90.vtx");
	AddFileToDownloadsTable("models/player/ics/allied_rocket/american_rocket.mdl");
	AddFileToDownloadsTable("models/player/ics/allied_rocket/american_rocket.phy");
	AddFileToDownloadsTable("models/player/ics/allied_rocket/american_rocket.sw.vtx");
	AddFileToDownloadsTable("models/player/ics/allied_rocket/american_rocket.vvd");
	AddFileToDownloadsTable("models/player/ics/allied_sniper/american_sniper.dx80.vtx");
	AddFileToDownloadsTable("models/player/ics/allied_sniper/american_sniper.dx90.vtx");
	AddFileToDownloadsTable("models/player/ics/allied_sniper/american_sniper.mdl");
	AddFileToDownloadsTable("models/player/ics/allied_sniper/american_sniper.phy");
	AddFileToDownloadsTable("models/player/ics/allied_sniper/american_sniper.sw.vtx");
	AddFileToDownloadsTable("models/player/ics/allied_sniper/american_sniper.vvd");
	AddFileToDownloadsTable("models/player/ics/allied_support/american_support.dx80.vtx");
	AddFileToDownloadsTable("models/player/ics/allied_support/american_support.dx90.vtx");
	AddFileToDownloadsTable("models/player/ics/allied_support/american_support.mdl");
	AddFileToDownloadsTable("models/player/ics/allied_support/american_support.phy");
	AddFileToDownloadsTable("models/player/ics/allied_support/american_support.sw.vtx");
	AddFileToDownloadsTable("models/player/ics/allied_support/american_support.vvd");
	///////////////////////////////// Axis models
	//Axis materials
	AddFileToDownloadsTable("materials/models/player/ics/axis_admin/german_body.vmt");
	AddFileToDownloadsTable("materials/models/player/ics/axis_admin/german_body.vtf");
	AddFileToDownloadsTable("materials/models/player/ics/axis_admin/german_gear.vmt");
	AddFileToDownloadsTable("materials/models/player/ics/axis_admin/german_gear.vtf");
	//Axis models
	AddFileToDownloadsTable("models/player/ics/axis_assault/german_assault.dx80.vtx");
	AddFileToDownloadsTable("models/player/ics/axis_assault/german_assault.dx90.vtx");
	AddFileToDownloadsTable("models/player/ics/axis_assault/german_assault.mdl");
	AddFileToDownloadsTable("models/player/ics/axis_assault/german_assault.phy");
	AddFileToDownloadsTable("models/player/ics/axis_assault/german_assault.sw.vtx");
	AddFileToDownloadsTable("models/player/ics/axis_assault/german_assault.vvd");
	AddFileToDownloadsTable("models/player/ics/axis_mg/german_mg.dx80.vtx");
	AddFileToDownloadsTable("models/player/ics/axis_mg/german_mg.dx90.vtx");
	AddFileToDownloadsTable("models/player/ics/axis_mg/german_mg.mdl");
	AddFileToDownloadsTable("models/player/ics/axis_mg/german_mg.phy");
	AddFileToDownloadsTable("models/player/ics/axis_mg/german_mg.sw.vtx");
	AddFileToDownloadsTable("models/player/ics/axis_mg/german_mg.vvd");
	AddFileToDownloadsTable("models/player/ics/axis_rifleman/german_rifleman.dx90.vtx");
	AddFileToDownloadsTable("models/player/ics/axis_rifleman/german_rifleman.dx80.vtx");
	AddFileToDownloadsTable("models/player/ics/axis_rifleman/german_rifleman.mdl");
	AddFileToDownloadsTable("models/player/ics/axis_rifleman/german_rifleman.phy");
	AddFileToDownloadsTable("models/player/ics/axis_rifleman/german_rifleman.sw.vtx");
	AddFileToDownloadsTable("models/player/ics/axis_rifleman/german_rifleman.vvd");
	AddFileToDownloadsTable("models/player/ics/axis_rocket/german_rocket.dx80.vtx");
	AddFileToDownloadsTable("models/player/ics/axis_rocket/german_rocket.dx90.vtx");
	AddFileToDownloadsTable("models/player/ics/axis_rocket/german_rocket.mdl");
	AddFileToDownloadsTable("models/player/ics/axis_rocket/german_rocket.phy");
	AddFileToDownloadsTable("models/player/ics/axis_rocket/german_rocket.sw.vtx");
	AddFileToDownloadsTable("models/player/ics/axis_rocket/german_rocket.vvd");
	AddFileToDownloadsTable("models/player/ics/axis_sniper/german_sniper.dx80.vtx");
	AddFileToDownloadsTable("models/player/ics/axis_sniper/german_sniper.dx90.vtx");
	AddFileToDownloadsTable("models/player/ics/axis_sniper/german_sniper.mdl");
	AddFileToDownloadsTable("models/player/ics/axis_sniper/german_sniper.phy");
	AddFileToDownloadsTable("models/player/ics/axis_sniper/german_sniper.sw.vtx");
	AddFileToDownloadsTable("models/player/ics/axis_sniper/german_sniper.vvd");
	AddFileToDownloadsTable("models/player/ics/axis_support/german_support.dx80.vtx");
	AddFileToDownloadsTable("models/player/ics/axis_support/german_support.dx90.vtx");
	AddFileToDownloadsTable("models/player/ics/axis_support/german_support.mdl");
	AddFileToDownloadsTable("models/player/ics/axis_support/german_support.phy");
	AddFileToDownloadsTable("models/player/ics/axis_support/german_support.sw.vtx");
	AddFileToDownloadsTable("models/player/ics/axis_support/german_support.vvd");
}

public Event_PlayerSpawn(Handle:event, const String:name[], bool:dontBroadcast)
{
	new client = GetClientOfUserId(GetEventInt(event, "userid"));
	if (GetUserAdmin(client) != INVALID_ADMIN_ID)
	{
		if (GetClientTeam(client) == 2)
		{
			
			switch (GetEntProp(client, Prop_Send, "m_iPlayerClass"))
			{
				case 0:
				{
					SetEntityModel(client, g_modelAmerName[0])
					SetEntityRenderColor(client, 255, 255, 255, 255);
				}
				
				case 1:
				{
					SetEntityModel(client, g_modelAmerName[1])
					SetEntityRenderColor(client, 255, 255, 255, 255);
				}
				
				case 2:
				{
					SetEntityModel(client, g_modelAmerName[2])
					SetEntityRenderColor(client, 255, 255, 255, 255);
				}
				
				case 3:
				{
					SetEntityModel(client, g_modelAmerName[3])
					SetEntityRenderColor(client, 255, 255, 255, 255);
				}
				
				case 4:
				{
					SetEntityModel(client, g_modelAmerName[4])
					SetEntityRenderColor(client, 255, 255, 255, 255);
				}
				
				case 5:
				{
					SetEntityModel(client, g_modelAmerName[5])
					SetEntityRenderColor(client, 255, 255, 255, 255);
				}
			}
		}
		
		else if (GetClientTeam(client) == 3)
		{
			switch (GetEntProp(client, Prop_Send, "m_iPlayerClass"))
			{
				case 0:
				{
					SetEntityModel(client, g_modelAxisName[0])
					SetEntityRenderColor(client, 255, 255, 255, 255);
				}
				
				case 1:
				{
					SetEntityModel(client, g_modelAxisName[1])
					SetEntityRenderColor(client, 255, 255, 255, 255);
				}
				
				case 2:
				{
					SetEntityModel(client, g_modelAxisName[2])
					SetEntityRenderColor(client, 255, 255, 255, 255);
				}
				
				case 3:
				{
					SetEntityModel(client, g_modelAxisName[3])
					SetEntityRenderColor(client, 255, 255, 255, 255);
				}
				
				case 4:
				{
					SetEntityModel(client, g_modelAxisName[4])
					SetEntityRenderColor(client, 255, 255, 255, 255);
				}
				
				case 5:
				{
					SetEntityModel(client, g_modelAxisName[5])
					SetEntityRenderColor(client, 255, 255, 255, 255);
				}
			}
		}
	}
}

